
Redmine - Patch #1671

Show a breakdown of estimated/spent/remaining time for a version

2008-07-21 19:27 - Artem Vasiliev

Status: New Start date: 2008-07-21

Priority: Normal Due date:  

Assignee: Mischa The Evil % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version: Candidate for next major release   

Description

It adds time metrics to Version page (click on Roadmap page, then on version link to get there).

We made it to help us plan future releases and better control in-progress ones.

What it does (see attached screenshot for example):

Remaining time above shows sum of issues' unspent estimates;

Total is Remaining + Spent, i.e. what time the version is going to take currently;

In Issue metrics box below it adds Time progress showing Spent vs. Total, and exact values for Estimate, Spent and Remaining

times for given category;

Issue metrics previously didn't show data for issues having chosen attribute not assigned. This is fixed here, see that [Not

Assigned] group in screenshot;

Drill-through links from Issue metrics box didn't show closed issues, this is fixed here.

Tests are included, translations are made for English and Russian, English stubs are made for other languages.

The patch is made against Redmine trunk r1682. It can be considered as solution to #1561.

Contributed by Texuna Technologies company.

Related issues:

Related to Redmine - Feature #2587: Improvement of built-in issue reports in ... Closed 2009-01-26

Related to Redmine - Feature #371: Show time tracking in the changelog/roadmap New

Related to Redmine - Defect #8106: Issues by Category should show tasks witho... Closed 2011-04-08

Related to Redmine - Feature #12220: Time tracking countdown New

Related to Redmine - Feature #13099: Issue Summary: add statistics about issu... Closed

Related to Redmine - Feature #24277: Introducing Remaining Time field as meth... New

Associated revisions

Revision 22858 - 2024-06-04 22:17 - Marius BĂLTEANU

Adds estimated remaining time to version page (#37862, #1671).

Revision 22860 - 2024-06-05 10:21 - Go MAEDA

Fix RuboCop offense Naming/MemoizedInstanceVariableName (#37862, #1671).

History

#1 - 2008-07-21 19:28 - Artem Vasiliev

- File version_times.patch added

#2 - 2008-07-21 19:59 - Eric Davis

Looks like the content of test/unit/version_test.rb is duplicated several times in the patch.

#3 - 2008-07-22 11:04 - Artem Vasiliev

- File version_times.patch added

#4 - 2008-07-22 11:05 - Artem Vasiliev

Eric Davis wrote:

Looks like the content of test/unit/version_test.rb is duplicated several times in the patch.
 Yes, right, occasionally version_test.rb contained the same class several times. Attached fixed version.

#5 - 2008-09-05 10:24 - Artem Vasiliev

Updated with

http://github.com/artemv/redmine_tt/commit/63d2bca24fbc56c44ab9d8cc49cf5bab1cd1af9c:

It introduces 'development complete' flag for issue status. Remaining time is

now calculated as max(estimated - spent, 0) only for open issues that are not in 'development complete'

status (we have only Resolved as such).

#6 - 2008-09-05 10:25 - Artem Vasiliev

Artem Vasiliev wrote:

Updated with

http://github.com/artemv/redmine_tt/commit/63d2bca24fbc56c44ab9d8cc49cf5bab1cd1af9c:

 + test fix for this: http://github.com/artemv/redmine_tt/commit/c5f25baf252685b7e5fa322ecc623b4024d10bc6

#7 - 2008-09-05 10:27 - Artem Vasiliev

Updated with

http://github.com/artemv/redmine_tt/commit/2f53878ce1f51cd5c797eaa8a98e6ed327e13b96

Version page: show not estimated (undone) issues count.

Count is a link that leads to relevant issues list.

For this 2 new filter operators added for status: 'done' (which is closed or 'development complete') and 'undone'.

#8 - 2008-09-05 10:32 - Artem Vasiliev

- File version_times.png added

#9 - 2008-09-09 19:52 - Weverton Morais

Will these changes be done on RedMine official next version?

#10 - 2008-09-10 10:02 - Artem Vasiliev

Weverton Morais wrote:

Will these changes be done on RedMine official next version?

 Not sure about it. But you could use version at http://github.com/artemv/redmine_tt/tree/master - it has 'download' button for getting zip. I'm keeping it

in sync with Redmine's trunk.

#11 - 2009-01-26 01:36 - Eric Davis

Artem Vasiliev wrote:

Not sure about it. But you could use version at http://github.com/artemv/redmine_tt/tree/master - it has 'download' button for getting zip. I'm

keeping it in sync with Redmine's trunk.

 Artem Vasiliev, any chance you can break your custom features into separate branches for me?  Then I can pull them into the core and you wouldn't

have to merge them anymore.  Right now I get a list of all your changes with no way to pick out single features.

#12 - 2009-01-26 08:14 - Artem Vasiliev

Eric Davis wrote:

Artem Vasiliev, any chance you can break your custom features into separate branches for me?  Then I can pull them into the core and you

wouldn't have to merge them anymore.  Right now I get a list of all your changes with no way to pick out single features.

 Hi Eric!

I think I could do that on feature-by-feature basis. E.g. you ask me to make individual branch for this (#1671) ticket and I do it. Ok?

Please note that I'll have much less time for Redmine starting from next week (02/02), so better start on this week.

Best regards,

Artem
#13 - 2009-04-16 10:50 - Javier Barroso

Hi,

We are interesting in using redmine_tt fork, but I have questions ...

How can we apply your redmine_tt diff into redmine ?

Is there any plan to integrate in trunk ?

Is it just integrated ?

Thank you

#14 - 2009-04-16 12:29 - Artem Vasiliev

Hi Javier!

Well you see, there's redmine_tt fork at GitHub. This is Redmine + our changes, so you can install it from beginning and work with it, or begin with

plain Redmine and then switch to redmine_tt keeping the same database.

Redmine is a big project and process of integrating community's changes is not easy, and there are no plans integrating redmine_tt's changes to

upstream AFAIK. And I'm not a Redmine core member after all )

But, redmine_tt can be upgraded time to time to merge changes from upstream thanks to Git's distributed nature. You can do it yourself, too: just

make a fork from redmine_tt and do what you want.

Best regards,

Artem

Javier Barroso wrote:

Hi,

We are interesting in using redmine_tt fork, but I have questions ...

How can we apply your redmine_tt diff into redmine ?

Is there any plan to integrate in trunk ?

Is it just integrated ?

Thank you

#15 - 2010-03-05 21:11 - mythos mint

This is great. I'm wondering, is there a way to modify this so I show the remaining time per month under "Projects->Overview->Details" 

(redmine/projects/project_name/timelog/details) ?

This is what I want: In March I have 20 hours dedicated to Project X. It already totals how many hours spent in the project from the issues. I just want

to show how many hours are remaining that month.

#16 - 2010-03-05 21:20 - mythos mint

It wouldn't let me upload an image, so I put it here @ http://i48.tinypic.com/s2fpdi.jpg

#17 - 2011-08-22 15:59 - Jérôme BATAILLE

Hi Artem, we are developping almost the same feature,

Have you worked on branches on your Github repository ?

#18 - 2011-08-22 23:19 - Terence Mill

+1 for core integration

#19 - 2011-10-14 10:32 - fake plastic tree

+1 for core integration

or at least a patch file for redmine 1.2.1

Is anyone working on this?

#20 - 2011-10-18 20:17 - Mischa The Evil

- Assignee set to Mischa The Evil

This is one of my favorite issues too. I'll see if I can port the patches to a current checkout of the Redmine trunk (upcoming Redmine 1.3.0).
#21 - 2014-05-15 14:52 - P S

- File version_times_251.diff added

I port this patch to Redmine 2.5.1

To apply patch download Redmine 2.5.1 and exec cmd

patch -p0 < version_times_251.diff

#22 - 2015-04-19 21:14 - Benoit Duffez

Is it patchable over Redmine 3.0.x?

#23 - 2015-12-15 17:06 - Ben Quinn

- File version_times_320.diff added

Updated the patch from P S for redmine 2.5.1 to work with redmine 3.2.0.

#24 - 2015-12-16 00:55 - Go MAEDA

- Target version set to Candidate for next major release

#25 - 2018-02-25 17:44 - Marius BĂLTEANU

- Related to Feature #24277: Introducing Remaining Time field as method to track the remaining time to complete an issue added

#26 - 2023-11-25 08:51 - pasquale [:dedalus]

Marius BĂLTEANU Go MAEDA

Could this ticket be included in the activities planned for version 6.0?

#27 - 2024-05-02 23:27 - Marius BĂLTEANU

I attached a patch to #37862 that brings the Estimated remaining time information in version page. Please take a look.

#28 - 2024-06-04 22:28 - Marius BĂLTEANU

Estimated remaining time added to version page in r22858, now we should only add the breakdown in order to implement all the requirements from

this issue.

Files

version_times.png 35.5 KB 2008-07-21 Artem Vasiliev

version_times.patch 52.2 KB 2008-07-21 Artem Vasiliev

version_times.patch 45.1 KB 2008-07-22 Artem Vasiliev

version_times.png 87.5 KB 2008-09-05 Artem Vasiliev

version_times_251.diff 15.5 KB 2014-05-15 P S

version_times_320.diff 14.1 KB 2015-12-15 Ben Quinn
